// lex_main.cpp
// VERSION 2
// Glenn G. Chappell
// 4 Feb 2013
//
// For CS 321 Spring 2013
// Quick main program for class Lex

#include "lex.h"  // For class Lex
#include <iostream>
using std::cout;
using std::endl;
#include <string>
using std::string;
#include <iomanip>
using std::setw;
using std::left;
using std::right;


// printLexemeLine
// Given a lexeme, print it on a single line: a string representation of
//  the token, padded with blanks, then the lexeme's string, then a
//  newline.
void printLexemeLine(const Lex::Lexeme & word)
{
    cout << setw(8) << left;
    switch (word.second)
    {
    case Lex::NONE:
        cout << "NONE";
        break;
    case Lex::ILLEGAL:
        cout << "ILLEGAL";
        break;
    case Lex::KEY:
        cout << "KEY";
        break;
    case Lex::ID:
        cout << "ID";
        break;
    case Lex::OP:
        cout << "OP";
        break;
    case Lex::PUNCT:
        cout << "PUNCT";
        break;
    case Lex::NUM:
        cout << "NUM";
        break;
    default:
        cout << "***** Error: bad token ***** ";
        break;
    }
    cout << right;
    cout << word.first << endl;
}


int main()
{
    string theprogram = "+.3 +.x#comment\nk - 4 k-4\nz\a (\\a after z)";

    // Print the input
    cout << "Input: " << endl;
    cout << theprogram << endl;
    cout << endl;

    // Print all lexemes in the input, each on a separate line
    cout << "Lexemes: " << endl;
    Lex luthor;
    for (luthor.set(theprogram);
         !luthor.done();
         luthor.advance())
    {
        printLexemeLine(luthor.current());
    }

    return 0;
}

